#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum IngestStatus {
    #[serde(rename = "IN_PROGRESS")]
    InProgress,
    #[serde(rename = "COMPLETED")]
    Completed,
    #[serde(rename = "FAILED")]
    Failed,
    #[serde(rename = "DELETION_IN_PROGRESS")]
    DeletionInProgress,
    #[serde(rename = "DELETED")]
    Deleted,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl IngestStatus {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            IngestStatus::InProgress => "IN_PROGRESS",
            IngestStatus::Completed => "COMPLETED",
            IngestStatus::Failed => "FAILED",
            IngestStatus::DeletionInProgress => "DELETION_IN_PROGRESS",
            IngestStatus::Deleted => "DELETED",
            IngestStatus::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for IngestStatus {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for IngestStatus {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for IngestStatus {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<IngestStatus, conjure_object::plain::ParseEnumError> {
        match v {
            "IN_PROGRESS" => Ok(IngestStatus::InProgress),
            "COMPLETED" => Ok(IngestStatus::Completed),
            "FAILED" => Ok(IngestStatus::Failed),
            "DELETION_IN_PROGRESS" => Ok(IngestStatus::DeletionInProgress),
            "DELETED" => Ok(IngestStatus::Deleted),
            v => v.parse().map(|v| IngestStatus::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for IngestStatus {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<IngestStatus, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the IngestStatus enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
